(* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *)
(*  Soubor: IZO.PAS                                                        *)
(*  Obsah: pokusny programek pro vykresleni stinovane izometricke mapy     *)
(*  Autor: Mircosoft (http://mircosoft.mzf.cz)                             *)
(*  Posledni uprava: 30.5.2013                                             *)
(*  Pro kompilaci: viz Uses                                                *)
(*  Pro spusteni: nic                                                      *)
(*  Upozorneni: tyto zdrojove kody pouzivate na vlastni nebezpeci          *)
(* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *)
program izo;
uses vesa,klavesy2;
{Jednoduche vykresleni izometricke stinovane mapy terenu. Pro prakticke
pouziti je potreba optimalizace (hlavne ulozeni souradnic vrcholu policek,
aby se nemusely pri kazdem kresleni znovu pocitat).

Ovladani: Escape konci, ostatni klavesy prisypavaji na mapu dalsi kopce}

const sirkamapy=10;
      vyskamapy=10;

var mapa:array[0..sirkamapy-1,0..vyskamapy] of byte;
    i,j,x,y:word;

procedure nasyp(y,x:word; maximum:byte);
Begin
if mapa[y,x]<maximum
  then begin
       inc(mapa[y,x]);
       if x<>0 then begin
                    nasyp(y,x-1,maximum-1);
                    if y<>0 then nasyp(y-1,x-1,maximum-1);
                    if y<vyskamapy-1 then nasyp(y+1,x-1,maximum-1);
                    end;
       if x<sirkamapy-1 then begin
                             nasyp(y,x+1,maximum-1);
                             if y<>0 then nasyp(y-1,x+1,maximum-1);
                             if y<vyskamapy-1 then nasyp(y+1,x+1,maximum-1);
                             end;
       if y<>0 then nasyp(y-1,x,maximum-1);
       if y<vyskamapy-1 then nasyp(y+1,x,maximum-1);
       end;
End;{nasyp}

procedure KresliPolicko(i,j:word);
const lhx=400; lhy=100; {poloha LH rohu mapy na obrazovce}
      vp=40;{velikost policka [px]}
      sin30=0.5; cos30=0.8660254037844; {sin a cos 30 stupnu}
      dx=round(vp*cos30);
      dy=round(vp*sin30);
      dz=15;
      svetla=10; tmava=120; stredni=2; {barvy pro stinovani terenu}
var x,y:array[1..4] of integer; {souradnice rohu policka}
    zvyseni:byte; {bitove pole - ktere rohy jsou zvysene}
    ba, {barva leve nebo dolni pulky policka}
    bb:byte; {barva prave nebo horni pulky policka}
{indexy pro pole x a y:          hodnoty pro Zvyseni:
       1                                   1
     /  \                                /  \
 4 /      \ 2                        8 /      \ 2
   \      /                            \      /
     \  /                                \  /
      3                                   4

x pribyva doprava dolu, y doleva dolu}
Begin
{zakladni souradnice rohu policka:}
x[1]:=lhx+dx*j-dx*i;
y[1]:=lhy+dy*i+dy*j-dz*mapa[i,j];
x[2]:=x[1]+dx;
y[2]:=y[1]+dy;
x[3]:=x[1];
y[3]:=y[1]+2*dy;
x[4]:=x[1]-dx;
y[4]:=y[1]+dy;
{Rohy sousedici s vyssimi policky se musi zvednout. Ktere to budou:}
zvyseni:=0;
if i<>0 then begin
             if mapa[i-1,j]>mapa[i,j] then zvyseni:=zvyseni or 1 or 2; {H}
             if (j<>0)and(mapa[i-1,j-1]>mapa[i,j]) then zvyseni:=zvyseni or 1; {LH}
             if (j<sirkamapy-1)and(mapa[i-1,j+1]>mapa[i,j]) then zvyseni:=zvyseni or 2; {PH}
             end;
if i<vyskamapy-1 then begin
                      if mapa[i+1,j]>mapa[i,j] then zvyseni:=zvyseni or 4 or 8; {D}
                      if (j<>0)and(mapa[i+1,j-1]>mapa[i,j]) then zvyseni:=zvyseni or 8; {LD}
                      if (j<sirkamapy-1)and(mapa[i+1,j+1]>mapa[i,j]) then zvyseni:=zvyseni or 4; {PD}
                      end;
if (j<>0)and(mapa[i,j-1]>mapa[i,j]) then zvyseni:=zvyseni or 1 or 8; {L}
if (j<sirkamapy-1)and(mapa[i,j+1]>mapa[i,j]) then zvyseni:=zvyseni or 2 or 4; {P}
{zvednuti rohu:}
if zvyseni and 1<>0 then dec(y[1],dz);
if zvyseni and 2<>0 then dec(y[2],dz);
if zvyseni and 4<>0 then dec(y[3],dz);
if zvyseni and 8<>0 then dec(y[4],dz);
{priprava barev podle sklonu terenu:}
case zvyseni of 0,15,6,9:begin ba:=stredni; bb:=stredni; end;
                1,2:     begin ba:=stredni; bb:=svetla;  end;
                3:       begin ba:=svetla;  bb:=svetla;  end;
                4,8:     begin ba:=tmava;   bb:=stredni; end;
                10:      begin ba:=svetla;  bb:=tmava;   end;
                7,11:    begin ba:=svetla;  bb:=stredni; end;
                14,13:   begin ba:=stredni; bb:=tmava;   end;
                12:      begin ba:=tmava;   bb:=tmava;   end;
                5:       begin ba:=tmava;   bb:=svetla;  end;
                end;
{vykresleni terenu:}
if zvyseni in [2,7,8,13] then begin {svisly predel}
                              __filledtriangle(x[1],y[1],x[3],y[3],x[4],y[4],ba);
                              __filledtriangle(x[1],y[1],x[2],y[2],x[3],y[3],bb);
                              __triangle(x[1],y[1],x[3],y[3],x[4],y[4],15);
                              __triangle(x[1],y[1],x[2],y[2],x[3],y[3],15);
                              end
                         else begin {vodorovny predel}
                              __filledtriangle(x[1],y[1],x[4],y[4],x[2],y[2],bb);
                              __filledtriangle(x[4],y[4],x[3],y[3],x[2],y[2],ba);
                              __triangle(x[1],y[1],x[4],y[4],x[2],y[2],15);
                              __triangle(x[4],y[4],x[3],y[3],x[2],y[2],15);
                              end;
{oznaceni stredu policka:}
__bar(x[1]-2,(y[1]+y[3])shr 1-2,x[1]+2,(y[1]+y[3])shr 1+2,14);
End;{kreslipolicko}

BEGIN
_setmode(_800x600);
randomize;
fillchar(mapa,sizeof(mapa),0);

 repeat
 y:=random(vyskamapy);
 x:=random(sirkamapy);
 nasyp(y,x,mapa[y,x]+1);

 _fill(0);
 for i:=0 to vyskamapy-1 do
  for j:=0 to sirkamapy-1 do kreslipolicko(i,j);

 until readkey=#27;

_setmode(0);
END.